* --------------------------------------------------------------------------------------------------------- *
* SYSTEM : MEMBERSHIP MANAGEMENT SYSTEM                                                                     *   
* AUTHOR : SWAPAN DAS                                                                                       *
*                                                                                                           *
* DATE   : 20-MAR-2009                                                                                      *
* LUPDT  : 04-MAY-2009                                                                                      *
*                                                                                                           *
* --------------------------------------------------------------------------------------------------------- *

/*
This form is my first hands-on experience with HMG, rather say my first attempt on GUI with Harbour/xHarbour
It has just started and will grow - menus, other forms, printing options etc.

At present the best part of it, is how I display & store member's photo and link it with dbf.
Can be kept/installed at any location, just create/keep a sub-folder PHOTO where all picture files containing
members' passport size photo will be kept.
C:\MEMBER:member.exe,member.dbf,0.BMP (yes keep this bmp here, will add to resource later on)
C:\MEMBER\PHOTO\*.bmp *.jpg all picture files here
* --------------------------------------------------------------------------------------------------------- *
*/
#include 'minigui.ch'
static lAddmode := .f.
static lOpened := .f.
static cWindowName:=''
static cControlName:=''
static cPhotoPath:=''
Function Main
	SetProg()
	CreateTable()
	MemberEntry()
Return nil

PROCEDURE MemberEntry
	if lOpened
		return
	endif
	lOpened := .t.
	cPhotoPath:=GetStartUpFolder()+[\Photo\]
	DEFINE WINDOW frmMember          ;
		AT 0,0               ;
		WIDTH 1000 HEIGHT 600 + IF(IsXPThemeActive(), 8, 0) ;
		TITLE 'Member Setup'   ;
		MAIN ;
		FONT 'ARIAL' SIZE 9         ;
		ON INIT   ( OpenTables() , DeactivateEdit() ) ;
		ON RELEASE CloseTables()
		DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50,30 FLAT RIGHTTEXT BORDER
			BUTTON btnFirst       ;
				CAPTION '&Top' ;
				picture "HP_TOP" ;
				ACTION ( dBGoTop() , frmMember.Browse_1.Value := RecNo() )
		
			BUTTON btnPrev    ;
				CAPTION '&Prev'    ;
				PICTURE "HP_BACK" ;
				ACTION ( dBSkip ( -1 ) , frmMember.Browse_1.Value := RecNo() )
		
			BUTTON btnNext   ;
				CAPTION '&Next'    ;
				PICTURE "HP_NEXT" ;
				ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) , frmMember.Browse_1.Value := RecNo() )
		
			BUTTON btnLast       ;
				CAPTION '&Last'    ;
				PICTURE "HP_END" ;
				ACTION ( dBGoBottom () , frmMember.Browse_1.Value := RecNo() )  SEPARATOR
			
			BUTTON btnFind       ;
				CAPTION '&Find'    ;
				PICTURE "MINIGUI_EDIT_FIND" ;
				ACTION FindRec()
			
			BUTTON btnAdd       ;
				CAPTION '&Add'    ;
				PICTURE "MINIGUI_EDIT_ADD" ;
				ACTION (lAddMode := .T., AddRec())
			
			BUTTON btnModify       ;
				CAPTION '&Modify'    ;
				PICTURE "MINIGUI_EDIT_EDIT" ;
				ACTION If ( CheckRLock() , ActivateEdit() , Nil )

			BUTTON btnDelete    ;
				CAPTION '&Delete'   ;
				PICTURE "MINIGUI_EDIT_DELETE" ;
				ACTION DeleteRec() ;

			BUTTON btnPrint    ;
				CAPTION '&Print'   ;
				PICTURE "MINIGUI_EDIT_PRINT" ;
				ACTION PrintRec() ;

			BUTTON btnClose    ;
				CAPTION '&Close'   ;
				PICTURE "MINIGUI_EDIT_CLOSE" ;
				ACTION CloseEntry()
		END TOOLBAR

		@ 56,10 BROWSE Browse_1 ;
			OF frmMember ; 
			WIDTH 190 ;
			HEIGHT 500 ;
			HEADERS { '', 'Sl#' , 'Member Name' } ;
			WIDTHS { 1, 30 , 150 } ;
			WORKAREA Member ;
			FIELDS { 'Member->Slno' ,'Member->Slno' , 'Member->Name' } ;
			ON CHANGE {|| RefreshData() } ;
			ON DBLCLICK ( ActivateEdit() , If ( ! CheckRLock() , DeactivateEdit() , Nil ) ) ;
			NOLINES;
			JUSTIFY { BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT }

		DEFINE TAB tabMemberInfo ;
			AT 56,210 ;
			WIDTH 700 ;
			HEIGHT 500 			            

			/* 	Page1: Member Info	*/
			
            PAGE 'Member Info'
			
				@ 66 , 010 LABEL lblSlNo ;
					VALUE 'Sl.#' ;
					WIDTH 80
				
				@ 66 , 090 TEXTBOX txtSlno ;
					MAXLENGTH 5 ;
					WIDTH 50 ;
					ON GOTFOCUS frmMember.lblSlno.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblSlno.FontBold := .F.

				@ 30 , 555 IMAGE imgPhoto ;
					PICTURE "0.BMP" ;
					WIDTH 100 HEIGHT 125

				@ 128,660 BUTTON btnPhotoCancel ;
						CAPTION "X" ;
						TOOLTIP "Click to Remove this photo against this member" ;
						ACTION PhotoCancel() ;
						WIDTH 25 ;
						HEIGHT 25 ;
						FONT "ARIAL" SIZE 12 ;
						ON GOTFOCUS frmMember.btnPhotoCancel.FontBold := .T. ;
						ON LOSTFOCUS frmMember.btnPhotoCancel.FontBold := .F. 

				@ 157,660 BUTTON btnPhotoSelection ;
						CAPTION "..." ;
						ACTION PhotoSelection() ;
						WIDTH 25 ;
						HEIGHT 25 ;
						FONT "ARIAL" SIZE 12 ;
						ON GOTFOCUS frmMember.btnPhotoSelection.FontBold := .T. ;
						ON LOSTFOCUS frmMember.btnPhotoSelection.FontBold := .F. 
				
				@ 157 , 555 TEXTBOX txtPhoto ;
					VALUE "" ;
					WIDTH 100 HEIGHT 25 ;
					READONLY ;
					FONT "ARIAL" SIZE 09
										
				@ 96 , 010 LABEL lblMem_ID ;
					VALUE 'Mem_ID' ;
					WIDTH 80

				@ 96 , 090 TEXTBOX txtMEM_ID ;
					MAXLENGTH 5 ;
					WIDTH 50 ;
					ON GOTFOCUS frmMember.lblMem_ID.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblMem_ID.FontBold := .F.

				@ 96 , 165 LABEL lblRenewInDays ;
					VALUE 'RenewInDays' ;
					WIDTH 80

				@ 96 , 255 LABEL lblCalRenewInDays ;
					VALUE '' ;
					WIDTH 80

				DEFINE CHECKBOX chkActive
					ROW	90
					COL	390
					CAPTION 'Yes Active ' 
					VALUE .T. 
					TOOLTIP 'Membership is Active or not' 
					ON GOTFOCUS frmMember.chkActive.FontBold := .T.
					ON LOSTFOCUS if(frmMember.chkActive.value=.f.,frmMember.chkActive.FontBold := .T.,frmMember.chkActive.FontBold := .F.)
					ONCHANGE ActiveInfo()
					//THREESTATE .T.
				END CHECKBOX

									
				@ 126 , 010 LABEL lblName ;
					VALUE 'Name' ;
					WIDTH 80
					@ 126 , 090 TEXTBOX txtName ;
					MAXLENGTH 50 ;
					WIDTH 300 ;
					ON GOTFOCUS frmMember.lblName.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblName.FontBold := .F. 
						
				@ 156 , 010 LABEL lblMem_Type ;
					VALUE 'Type' ;
					WIDTH 80
			
				@ 156,090 COMBOBOX cmbMem_Type ;
					WIDTH 100 ;
					ITEMS { 'A | Founder' , 'B | Core' , 'C | Regd.' } ;
					VALUE 3 ;
					ON GOTFOCUS frmMember.lblMem_Type.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblMem_Type.FontBold := .F.
					
				@ 186 , 010 LABEL lblDt_Of_Join ;
					VALUE 'Dt. of Joining' ;
					WIDTH 80
				@ 186,090 DATEPICKER dtpDt_Of_Join ;
					WIDTH 105 ;
					SHOWNONE ;
					ON GOTFOCUS frmMember.lblDt_Of_Join.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblDt_Of_Join.FontBold := .F. 
					
				@ 186 , 250 LABEL lblDt_Of_Paid ;
					VALUE 'Last Paid' ;
					WIDTH 80

				@ 186,350 DATEPICKER dtpDt_Of_Paid ;
					WIDTH 105 ;
					SHOWNONE ;
					ON GOTFOCUS frmMember.lblDt_Of_Paid.FontBold := .T. ;
					ON LOSTFOCUS ValidDateOfLastPaid()

				@ 186 , 475 LABEL lblDt_Of_Rnew ;
					VALUE 'Next Renewal' ;
					WIDTH 80
				@ 186,555 DATEPICKER dtpDt_Of_Rnew ;
					WIDTH 105 ;
					SHOWNONE ;	
					ON GOTFOCUS frmMember.lblDt_Of_Rnew.FontBold := .T. ;
					ON LOSTFOCUS ValidRenewInDays()
				
				// DRAW LINE HERE IN WINDOW frmMember.Frame_1 AT 56,210 TO <nRow>,<nCol> 
						
				@ 216 , 010 LABEL lblAdd1 ;
					VALUE 'Address' ;
					WIDTH 80
				@ 216 , 090 TEXTBOX txtAdd1 ;
					MAXLENGTH 40 ;
					WIDTH 300 ;
					ON GOTFOCUS frmMember.lblAdd1.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblAdd1.FontBold := .F. 
		
				@ 246 , 010 LABEL lblAdd2 ;
					VALUE '      ' ;
					WIDTH 80
				@ 246 , 090 TEXTBOX txtAdd2 ;
					MAXLENGTH 40 ;
					WIDTH 300 ;
					ON GOTFOCUS frmMember.lblAdd1.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblAdd1.FontBold := .F. 
			
				@ 276 , 010 LABEL lblAdd3 ;
					VALUE '       ' ;
					WIDTH 80
				@ 276 , 090 TEXTBOX txtAdd3 ;
					MAXLENGTH 40 ;
					WIDTH 300 ;
					ON GOTFOCUS frmMember.lblAdd1.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblAdd1.FontBold := .F. 
			
				@ 306 , 010 LABEL lblCity ;
					VALUE 'City' ;
					WIDTH 80
				@ 306, 090 TEXTBOX txtCity ;
					MAXLENGTH 40 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblCity.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblCity.FontBold := .F. 

				@ 306 , 315 LABEL lblPIN ;
					VALUE 'PIN' ;
					WIDTH 75 ;
					RIGHTALIGN
				@ 306, 415 TEXTBOX txtPinCode ;
					MAXLENGTH 10 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblPin.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblPin.FontBold := .F. 

				@ 336 , 010 LABEL lblState ;
					VALUE 'State' ;
					WIDTH 80
				@ 336 , 090 TEXTBOX txtState ;
					MAXLENGTH 30 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblState.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblState.FontBold := .F. 

				@ 336 , 315 LABEL lblCountry ;
					VALUE 'Country' ;
					WIDTH 75 ;
					RIGHTALIGN
				@ 336, 415 TEXTBOX txtCountry ;
					MAXLENGTH 15 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblCountry.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblCountry.FontBold := .F. 

				@ 366 , 010 LABEL lblMobile ;
					VALUE 'Mobile no.' ;
					WIDTH 80
				@ 366 , 090 TEXTBOX txtMobile ;
					MAXLENGTH 10 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblMobile.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblMobile.FontBold := .F. 

				@ 366 , 315 LABEL lblPhone ;
					VALUE 'Phone No.' ;
					WIDTH 75 ;
					RIGHTALIGN
				@ 366, 415 TEXTBOX txtPhone ;
					MAXLENGTH 20 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblPhone.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblPhone.FontBold := .F. 

				@ 396 , 010 LABEL lblEmail ;
					VALUE 'Email' ;
					WIDTH 80
				@ 396 , 090 TEXTBOX txtEmail ;
					MAXLENGTH 50 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblEmail.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblEmail.FontBold := .F. 
											
				@ 396 , 315 LABEL lblWebsite ;
					VALUE 'Website/Blog' ;
					WIDTH 75 ;
					RIGHTALIGN
				@ 396, 415 TEXTBOX txtWebsite ;
					MAXLENGTH 50 ;
					WIDTH 200 ;
					ON GOTFOCUS frmMember.lblWebsite.FontBold := .T. ;
					ON LOSTFOCUS frmMember.lblWebsite.FontBold := .F. 

				@ 426 , 010 LABEL lblGender ;
					VALUE 'Gender' ;
					WIDTH 80

				DEFINE RADIOGROUP optGender
					ROW    426
					COL    090
					WIDTH  100
					HEIGHT 30
					OPTIONS {'Male','Female'}
					VALUE 1
					FONTNAME "Arial"
					FONTSIZE 9
					TOOLTIP ""
					ONCHANGE NIL
					FONTBOLD .F.
					FONTITALIC .T.
					FONTUNDERLINE .F.
					FONTSTRIKEOUT .F.
					HELPID NIL
					TABSTOP .T.
					VISIBLE .T.
					TRANSPARENT .F.
					SPACING 100
					BACKCOLOR NIL
					FONTCOLOR NIL
					HORIZONTAL .T.
				END RADIOGROUP

				@ 426 , 315 LABEL lblDt_Of_Birth ;
					VALUE 'DOB/Birthday' ;		
					TOOLTIP "To undislose Year from Date of Birth - supply 1900 in Year field" ;
					WIDTH 75 ;
					RIGHTALIGN
				@ 426 , 530 LABEL lblDOBFormat ;
					VALUE '(DD/MM/YYYY)' ;		
					TOOLTIP "To undislose Year from Date of Birth - supply 1900 in Year field" ;
					WIDTH 100

				@ 426,415 TEXTBOX txtDt_Of_Birth ;
					WIDTH 80 ;
					TOOLTIP "To undislose Year from Date of Birth - supply 1900 in Year field" ;
					VALUE '01-01-1900' ;
					INPUTMASK '99-99-9999' ;
					ON GOTFOCUS frmMember.lblDt_Of_Birth.FontBold := .T. ;                
					ON LOSTFOCUS CheckDOB()

				@ 456,100 BUTTON cmdSave ;
					CAPTION '&Save' ;
					PICTURE "MINIGUI_EDIT_OK" LEFT ;
					ACTION SaveRec()
	
				@ 456,200 BUTTON cmdCancel ;
					CAPTION '&Cancel' ;
					PICTURE "MINIGUI_EDIT_CANCEL"  LEFT ;
					ACTION CancelRec()

			END PAGE
			
			/* Page2: Payment Info	*/
			
			PAGE 'Payment Info'
				@ 96 , 010 LABEL lblTab2 ;
				VALUE 'PAYMENT INFO - UNDER CONSTRUCTION!' ;
				WIDTH 300

				
			END PAGE
						
        END TAB
			
	END WINDOW

    DeactivateEdit()	
	frmMember.Browse_1.SetFocus
	CENTER WINDOW frmMember
	ACTIVATE WINDOW frmMember

RETURN

PROCEDURE OpenTables
	select member
	set order to tag slno && name
	GO TOP
	frmMember.Browse_1.value := member->(recno())
RETURN

PROCEDURE CloseTables
	lOpened := .f.
RETURN

PROCEDURE DeactivateEdit
	frmMember.txtslno.enabled        := .f.   
	frmMember.txtmem_id.enabled      := .f. 
	frmMember.txtname.enabled        := .f. 
	frmMember.cmbMem_type.enabled    := .f. 
	frmMember.optGender.enabled      := .f.
	frmMember.txtadd1.enabled        := .f. 
	frmMember.txtadd2.enabled        := .f. 
	frmMember.txtadd3.enabled        := .f. 
	frmMember.txtcity.enabled        := .f. 
	frmMember.txtpincode.enabled     := .f. 
	frmMember.txtstate.enabled       := .f. 
	frmMember.txtcountry.enabled     := .f. 
	frmMember.txtemail.enabled       := .f. 
	frmMember.txtwebsite.enabled     := .f. 
	frmMember.txtmobile.enabled      := .f. 
	frmMember.txtphone.enabled       := .f. 
	frmMember.dtpdt_of_join.enabled  := .f. 
	frmMember.dtpdt_of_rnew.enabled  := .f. 
	frmMember.dtpdt_of_paid.enabled  := .f. 
	frmMember.txtDt_Of_Birth.enabled := .f.
	frmMember.imgPhoto.enabled       := .f.
	frmMember.txtphoto.enabled       := .f. 
	frmMember.btnPhotoSelection.enabled		:= .f.
	frmMember.btnPhotoCancel.enabled		:= .f.
	frmMember.chkActive.enabled      := .f. 
	frmMember.cmdSave.Enabled        := .F.
	frmMember.cmdCancel.Enabled      := .F.
	frmMember.ToolBar_1.Enabled      := .T.
	frmMember.Browse_1.Enabled       := .T.
	frmMember.Browse_1.SetFocus
RETURN

PROCEDURE ActivateEdit
	frmMember.txtslno.enabled        := .f.   
	frmMember.txtmem_id.enabled      := .t. &&lAddMode 
	frmMember.txtname.enabled        := .t. 
	frmMember.cmbMem_type.enabled    := .t. 
	frmMember.optGender.enabled      := .t.
	frmMember.txtadd1.enabled        := .t. 
	frmMember.txtadd2.enabled        := .t. 
	frmMember.txtadd3.enabled        := .t. 
	frmMember.txtcity.enabled        := .t. 
	frmMember.txtpincode.enabled     := .t. 
	frmMember.txtstate.enabled       := .t. 
	frmMember.txtcountry.enabled     := .t. 
	frmMember.txtemail.enabled       := .t. 
	frmMember.txtwebsite.enabled     := .t. 
	frmMember.txtmobile.enabled      := .t. 
	frmMember.txtphone.enabled       := .t. 
	frmMember.dtpdt_of_join.enabled  := .t. 
	frmMember.dtpdt_of_rnew.enabled  := .t. 
	frmMember.dtpdt_of_paid.enabled  := .t. 
	frmMember.txtDt_Of_Birth.enabled := .t.
	frmMember.imgPhoto.enabled       := .t.
	frmMember.txtphoto.enabled   	 := .t. 
	frmMember.btnPhotoSelection.enabled		:= .t.
	frmMember.btnPhotoCancel.enabled		:= .t.
	frmMember.chkActive.enabled      := .t. 
	frmMember.Browse_1.Enabled       := .f.
	frmMember.cmdSave.Enabled        := .t.
	frmMember.cmdCancel.Enabled      := .t.
	frmMember.ToolBar_1.Enabled      := .f.
	frmMember.txtMEM_ID.SetFocus
RETURN

PROCEDURE CloseEntry()
	ThisWindow.Release
RETURN

PROCEDURE PrintRec()
	msgbox("Not yet Developed!");return
RETURN


PROCEDURE CancelRec()
	DeactivateEdit()
	RefreshData()
	UNLOCK
	lAddmode := .f.
RETURN


PROCEDURE SaveRec()
	local mOldrec
	Local vTxtSlno := Val( frmMember.txtSlno.Value ) 
	if empty(frmMember.txtName.value)
		msgbox("Member Name cannot be blank!"); frmMember.txtName.SetFocus(); return
	endif
	if frmMember.cmbMem_Type.value=0
		msgbox("Please Assign Membership Type!"); frmMember.cmbMem_Type.SetFocus(); return
	endif
	select member
	mOldrec = iif(eof(), 0, recno())
	if !empty(upper(frmMember.txtMEM_ID.value))
		select member
		locate for mem_id = upper(frmMember.txtMEM_ID.value) .and. (lAddmode .or. recno() <> mOldrec)
		if found()
			if mOldrec <> 0
				go mOldrec
			endif
			msgbox("Duplicate Member ID!"); frmMember.txtMEM_ID.setfocus(); return
		endif
	endif && if !empty(upper(frmMember.txtMEM_ID.value))
	locate for upper(name) = upper(frmMember.txtName.value) .and. (lAddmode .or. recno() <> mOldrec)
	if found()
		if mOldrec <> 0
			go mOldrec
		endif
		msgbox("Duplicate Member Name!"); frmMember.txtName.setfocus(); return
	endif
	if mOldrec <> 0
		go mOldrec
	endif
	If lAddmode == .T.
		If vTxtSlno <= 0
			Goto Bottom
			vTxtSlno := Member->Slno + 1
			member->(DbAppend())
			Replace Member->Slno With vTxtSlno
			commit     
			unlock
		Endif
	Endif && If lAddmode == .T. 
	DeactivateEdit()
	member->mem_id      := frmMember.txtmem_id.value      
	member->name        := frmMember.txtname.value              
	if frmMember.cmbMem_Type.value=1
		member->mem_type    :=	[1] // or [A]
		member->memtype    	:=	[FOUNDER]
	elseif frmMember.cmbMem_Type.value=2
		member->mem_type    :=	[2]
		member->memtype    	:=	[CORE]
	elseif frmMember.cmbMem_Type.value=3
		member->mem_type    :=	[3]
		member->memtype    	:=	[REGD]		
	else
		member->mem_type    :=	[ ]
		member->memtype    	:=	spac(len(member->memtype))
	endif
	member->Gender      := iif(frmMember.optGender.value=1,'M','F')
	member->add1        := frmMember.txtadd1.value        
	member->add2        := frmMember.txtadd2.value        
	member->add3        := frmMember.txtadd3.value        
	member->city        := frmMember.txtcity.value        
	member->pincode     := frmMember.txtpincode.value     
	member->state       := frmMember.txtstate.value       
	member->country     := frmMember.txtcountry.value     
	member->email       := frmMember.txtemail.value       
	member->website     := frmMember.txtwebsite.value     
	member->mobile      := frmMember.txtmobile.value      
	member->phone       := frmMember.txtphone.value       
	member->dt_of_join  := frmMember.dtpdt_of_join.value  
	member->dt_of_rnew  := frmMember.dtpdt_of_rnew.value  
	member->dt_of_paid  := frmMember.dtpdt_of_paid.value  
	if(year(ctod(frmMember.txtDt_Of_Birth.value)))>0
		if ctod(frmMember.txtDt_Of_Birth.value)=ctod("01-01-1900")
			member->dob  		:= ctod("")
		else
			member->dob  		:= ctod(frmMember.txtDt_Of_Birth.value)
		endif 
	endif
	member->photo   	:= alltrim(frmMember.txtphoto.value)
	member->active      := frmMember.chkActive.value      
	frmMember.Browse_1.Refresh
    frmMember.Browse_1.Value := member->(RecNo())
RETURN



PROCEDURE AddRec()
	Local strDate
	Local dNextRenewDate
	frmMember.txtslno.value        := "" 
	frmMember.txtmem_id.value      := '' 
	frmMember.txtname.value        := '' 
	frmMember.cmbMem_type.value    := 3
	frmMember.optGender.value	   :=1
	frmMember.txtadd1.value        := '' 
	frmMember.txtadd2.value        := '' 
	frmMember.txtadd3.value        := '' 
	frmMember.txtcity.value        := '' 
	frmMember.txtpincode.value     := '' 
	frmMember.txtstate.value       := '' 
	frmMember.txtcountry.value     := '' 
	frmMember.txtemail.value       := '' 
	frmMember.txtwebsite.value     := '' 
	frmMember.txtmobile.value      := '' 
	frmMember.txtphone.value       := '' 
	frmMember.dtpdt_of_join.value  := date() 
	frmMember.dtpdt_of_paid.value  := date() 
	frmmember.txtdt_of_birth.value := "01-01-1900"
	frmMember.imgPhoto.Picture     := '0.BMP' 
	frmMember.txtphoto.value       := '0.BMP' 
	frmMember.txtphoto.Tooltip		:= alltrim(cPhotoPath)
	frmMember.chkActive.value      := .T. 
	strDate=dtoc(frmMember.dtpDt_Of_Paid.Value)
	dNextRenewDate=ctod(substr(strDate,1,2)+[/]+substr(strDate,4,2)+[/]+ltrim(str(year(frmMember.dtpDt_Of_Paid.Value)+1)))
	frmMember.dtpdt_of_rnew.value  := dNextRenewDate
	CalRenewInDays()	
	ActivateEdit()
RETURN

PROCEDURE RefreshData()
	Local ret
	Local nMem_Type:=0
	frmMember.txtslno.value        := alltrim(str(member->slno))
	frmMember.txtmem_id.value      := alltrim(member->mem_id)      
	frmMember.txtname.value        := member->name        
	if member->mem_type = [1] // or [A]
		nMem_Type=1
	elseif member->mem_type = [2] // or [B]
		nMem_Type=2
	elseif member->mem_type = [3] // or [C]
		nMem_Type=3
	else
		nMem_Type=0
	endif
    frmMember.cmbMem_Type.value:=nMem_Type
	frmMember.optGender.value      := iif(member->Gender='F',2,1)	         
	frmMember.txtadd1.value        := member->add1        
	frmMember.txtadd2.value        := member->add2
	frmMember.txtadd3.value        := member->add1
	frmMember.txtcity.value        := member->city        
	frmMember.txtpincode.value     := member->pincode     
	frmMember.txtstate.value       := member->state       
	frmMember.txtcountry.value     := member->country     
	frmMember.txtemail.value       := member->email       
	frmMember.txtwebsite.value     := member->website     
	frmMember.txtmobile.value      := member->mobile      
	frmMember.txtphone.value       := member->phone       
	frmMember.dtpdt_of_join.value  := member->dt_of_join  
	frmMember.dtpdt_of_rnew.value  := member->dt_of_rnew  
	frmMember.dtpdt_of_paid.value  := member->dt_of_paid  
	frmMember.dtpdt_of_paid.value  := member->dt_of_paid
	frmMember.txtDt_Of_Birth.value := if(empty(member->dob),"01-01-1900",dtoc(member->dob))
	frmMember.txtphoto.value       := if (empty(member->photo),"0.BMP",alltrim(member->photo))
	if upper(frmMember.txtphoto.value)="0.BMP"
		frmMember.imgPhoto.Picture	:= "0.BMP"
		frmMember.txtphoto.Tooltip	:= alltrim(cPhotoPath)
	else
		frmMember.imgPhoto.Picture	:= alltrim(cPhotoPath)+frmMember.txtphoto.value
		frmMember.txtphoto.Tooltip	:= alltrim(cPhotoPath)+frmMember.txtphoto.value
	endif
	frmMember.chkActive.value      := member->active      
	*/
	ActiveInfo()
	CalRenewInDays()
	ret:=CTOD(alltrim(frmMember.txtDt_Of_Birth.Value))
	if year(ret)=0
		frmMember.txtDt_Of_Birth.value := "01-01-1900"
	endif
Return
/*
PROCEDURE CancelRec
	DeactivateEdit()  
	frmMember.btnAdd.Enabled := .t.
	frmMember.Browse_1.Enabled := .t.
	RefreshData()
	frmMember.Browse_1.SetFocus
Return
*/
Function CheckRLock()
	Local RetVal
	If member->(RLock())
	  RetVal := .t.
	Else
	  MsgExclamation ('Another user already locked this record')
	  RetVal := .f.
	EndIf
Return RetVal

Procedure DeleteRec
	Local vRecno := frmMember.Browse_1.Value
	Goto vRecno
	If MsgYesNo( "Delete This Record?"+CRLF+CRLF+;
		"Sl.No.: "+alltrim(str(Member->Slno))+CRLF+;
		"Mem_ID: "+alltrim(Member->Mem_ID)+CRLF+;
		"Type  : "+alltrim(Member->Mem_Type)+CRLF+;
		"Name  : "+alltrim(Member->Name), "Confirmation" )
		Delete
		Skip -1
		frmMember.Browse_1.Value := Member->(Recno())
		frmMember.Browse_1.Refresh
		frmMember.Browse_1.SetFocus
	Endif

/*
	select payment
	locate for mem_id = member->mem_id
	if found()
		msgbox("Cannot delete ... reference exists in Payment file "+alltrim(payment->slno));return
	endif
*/




Return


Procedure FindRec
	Local mName, mOldrecno
	mName := Upper ( AllTrim ( InputBox( 'Search Customer:' , 'Search' ) ) )
	If .Not. Empty(mName)
	   	mOldrecno = iif(member->(eof()), 0, member->(recno()))
                set order to tag name
                go top   
		If member->(dbseek(mName))
			frmMember.Browse_1.Value := member->(RecNo())
		Else
			MsgExclamation('No records found')
		EndIf
                set order to tag slno
                go top
		if mOldrecno <> 0
			member->(dbgoto(mOldrecno))
		endif
     	        frmMember.Browse_1.Refresh
                //RefreshData()

	EndIf
Return

Function ActiveInfo()
    Local ret
    ret:=frmMember.chkActive.Value
    frmMember.chkActive.FontBold := .f.
    if valtype(ret) == 'U'
        //MsgInfo('Not Defined')
        frmMember.chkActive.Caption   := '?   Active '
        frmMember.chkActive.FontColor := BLACK
        frmMember.chkActive.FontBold := .f.
        frmMember.chkActive.FontColor := BLACK
        frmMember.chkActive.FontBold := .f.
    elseif ret == .t.
        //MsgInfo('Active!')
        frmMember.chkActive.Caption   := 'Yes Active '
        frmMember.chkActive.FontColor := BLACK
        frmMember.chkActive.FontBold := .f.
    else
        //MsgInfo('Not Active')
        frmMember.chkActive.Caption   := 'Not Active '
        frmMember.chkActive.FontColor := RED
        frmMember.chkActive.FontBold := .t.
    endif
Return Nil

Function CalRenewInDays()
	if year(frmMember.dtpDt_Of_Rnew.Value)=0
		frmMember.lblCalRenewInDays.Value		:=[<Renewal Date not assigned>]
		frmMember.lblCalRenewInDays.FontSize 	:= 8
		frmMember.lblCalRenewInDays.FontColor 	:= RED
		frmMember.lblCalRenewInDays.FontBold 	:= .t.
	elseif frmMember.dtpDt_Of_Rnew.Value-date()>0
		frmMember.lblCalRenewInDays.Value		:=alltrim(str(frmMember.dtpDt_Of_Rnew.Value-date()))
		frmMember.lblCalRenewInDays.FontSize 	:= 14
		frmMember.lblCalRenewInDays.FontColor 	:= BLACK
		frmMember.lblCalRenewInDays.FontBold 	:= .t.
	else
		frmMember.lblCalRenewInDays.Value		:=alltrim(str(frmMember.dtpDt_Of_Rnew.Value-date()))
		frmMember.lblCalRenewInDays.FontSize 	:= 14
		frmMember.lblCalRenewInDays.FontColor 	:= RED
		frmMember.lblCalRenewInDays.FontBold 	:= .t.
	endif
Return Nil

Function ValidRenewInDays()
	CalRenewInDays() 
	frmMember.lblDt_Of_Rnew.FontBold := .F. 
Return nil

Function ValidDateOfLastPaid()
	CalDateOfNextRenewal()
	frmMember.lblDt_Of_Paid.FontBold := .F.
Return Nil

Function CalDateOfNextRenewal()
	Local strDate
	Local dNextRenewDate
	if empty(frmMember.dtpDt_Of_Rnew.Value)
		if !empty(frmMember.dtpDt_Of_Paid.Value)
			strDate=dtoc(frmMember.dtpDt_Of_Paid.Value)
			dNextRenewDate=ctod(substr(strDate,1,2)+[/]+substr(strDate,4,2)+[/]+ltrim(str(year(frmMember.dtpDt_Of_Paid.Value)+1)))
			frmMember.dtpdt_of_rnew.value  := dNextRenewDate
		endif
	else
	endif
Return Nil

Function GenderInfo()
	frmMember.lblGender.FontBold := .t.
Return Nil

Function CheckDOB()
	Local ret
	ret:=CTOD(alltrim(frmMember.txtDt_Of_Birth.Value))
	if year(ret)=0
		msgbox("Invalid Date!")
		frmMember.txtDt_Of_Birth.SetFocus
		return .f.
	else
		frmMember.lblDt_Of_Birth.FontBold := .F.	
	endif
Return Nil

Function PhotoSelection()
	Local x
	LOCAL aFilters := { {'jpg Files','*.jpg'},{'gif Files','*.gif'},{'png Files','*.png'},{'bmp Files','*.bmp'},{'pcx Files','*.pcx'} }
	x := Getfile ( { {'All Files','*.*'} } , 'Select Photo' , 'PHOTO\' , .f. , .f. )
	if !empty(x)
		frmMember.txtphoto.value		:= alltrim(FileBase(x))
		frmMember.txtphoto.Tooltip		:= alltrim(cPhotoPath)+frmMember.txtphoto.value
		frmMember.imgPhoto.Picture		:= x
	endif
Return Nil

Function PhotoCancel
		frmMember.txtphoto.value		:= "0.BMP"
		frmMember.txtphoto.Tooltip		:= alltrim(cPhotoPath)
		frmMember.imgPhoto.Picture		:= "0.BMP"
Return nil

FUNCTION FileBase( cFile )
	LOCAL nPos
	If (nPos := RAT("\", cFile)) != 0
	 RETURN SUBSTR(cFile, nPos + 1)
	Elseif (nPos := AT(":", cFile)) != 0
	 RETURN SUBSTR(cFile, nPos + 1)
	Else
	 RETURN cFile
	Endif
Return Nil

Function SetProg()
	set talk off
	set dele on
	set date ital
	set cent on
	set epoch to 1950
	SET BROWSESYNC ON
	SET NAVIGATION EXTENDED
	SET INTERACTIVECLOSE QUERY MAIN
	set font to "Arial", 09
	REQUEST DBFCDX , DBFFPT
	RDDSETDEFAULT( "DBFCDX" )
return nil

FUNCTION CreateTable()
	close databases
	/*sorry routine for member.dbf file creation not written*/
	use member new
	select member
	index on slno TAG slno to member
	index on mem_id TAG mem_id to member
	index on upper(name) TAG name to member
	set index to member
	set order to slno
return nil

***************************
Function BoldControl(cFormName,cCtrlName)
	frmMember.lblName.FontBold := .T.
return nil
